st7/
;demontracja uzycia generatora PWM0 do regulacji
;predkosci obrotowej silnika elektrycznego


	MOTOROLA			;format MOTOROLA (.s19)

	#include "st7flite29.inc"

;segmenty pamieci
	BYTES
	segment byte at 80-FF 'ram0'
	segment byte at 100-1FF 'stack'
	segment byte at 200-27F 'ram1'
	segment byte at 1000-10FF 'eeprom'
	segment byte at E000-FFDF 'program'
	segment byte at FFE0-FFFF 'intvect'




	BYTES
;deklaracje zmiennych
	segment 'ram0'
vvolts	DS.W		;wynik pomiaru napiecia


;deklaracje stalych
	WORDS
	segment 'program'


;-------------------------------------------------------
; inicjalizacja trybw pracy portw
; PA5 - wyjscie, reszta wejscia
; PB0,PB3 - wyjscia, reszta wejscia
;-------------------------------------------------------
PADR_init	EQU	%00000000
PADDR_init	EQU	%00000100
PAOR_init	EQU	%00000100
PBDR_init	EQU	%00000000
PBDDR_init	EQU	%00000000
PBOR_init	EQU	%00000000

PORTS_INIT MACRO
	ld	A,#PBDDR_init		;inicjalizacja portu B
	ld	PBDDR,A
	ld	A,#PBOR_init
	ld	PBOR,A
	ld	A,#PBDR_init
	ld	PBDR,A

	ld	A,#PADDR_init		;inicjalizacja portu A
	ld	PADDR,A
	ld	A,#PAOR_init
	ld	PAOR,A
	ld	A,#PADR_init
	ld	PADR,A
	MEND


;-------------------------------------------------------
;pomiar napiecia (wartosc zmierzona w komorce VVOLTS
;-------------------------------------------------------
volts
	clr	ADCCSR		;inicjacja rejestru kontrolnego, wylaczenie przetwornika
	clr	ADCDRL		;nastawa rejestru czasu pomiaru i wzmacniacza wejsciowego
	ld	A,#$40		;ustawienie szybkosc przetwarzania (SPEED=1)
	ld	ADCCSR,A
	ld	A,ADCDRH		;kasowanie flagi EOC
	ld	A,#$06
	ld	ADCCSR,A		;zalaczenie kanalu pomiarowego AIN6
	or	A,#$20		;uruchomienie pomiaru
	ld	ADCCSR,A
	btjf	ADCCSR,#7,*	;oczekiwanie na zakonczenie pomiaru
	clr	vvolts		;kompozycja starszego bajtu wyniku
	ld	X,vvolts		;ustawienie dwch  najmlodszych bitw przez przesuniecie z flaga C
	ld	A,ADCDRH
	sll	A
	rlc	X
	sll	A
	rlc	X
	ld	vvolts,X		;zapamietanie starszego bajtu
	ld	{vvolts+1},A	;kompozycja mlodszego bajtu suma z dwoma mlodszymi bitami z ADCDRL
	ld	A,ADCDRL
	and	A,#$03		;maskowanie nieznaczacych bitw
	or	A,{vvolts+1}	;sumowanie D0 i D1 wyniku
	ld	{vvolts+1},A	;zapamietanie wyniku pomiaru
	ret


;program glwny: w nim pomiar napiecia i ustawienie
;predkosci obrotowej silnika poprzez zmiane wypelnienia
;przebiegu na wyjsciu generatora PWM0
TMRREFH	EQU	$0F		;wartosc odswiezajaca timer
TMRREFL	EQU	$38
TMRMAXH	EQU	$0F		;wartosc maksymalna,ktora mozna wpisac do PWM
TMRMAXL	EQU	$FE

main
	PORTS_INIT		;inicjalizacja portw
 	ld	A,#$10
	ld	ATCSR,A		;nastawy PWM, f=40kHz@16MHz
	ld	A,#TMRREFH	;8x10^6/(4096-ATRH:ATRL), ATR=0x0F38
	ld	ATRH,A
	ld	A,#TMRREFL
	ld	ATRL,A
			
	ld	A,#$02		;sygnal PWM0 bez z inwersja
	ld	PWM0CSR,A                         
	ld	A,#$01		;zalaczone wyjscie PWM0
	ld	PWMCR,A
	clr	BREAKCR;		;funkcja BREAK wylaczona

mloop
	call	volts		;pomiar napiecia na wejsciu AIN6
	rcf
	srl	vvolts		;odrzucam 2 najmlodsze bity wyniku
	rrc	{vvolts+1}
	srl	vvolts
	rrc	{vvolts+1}

	ld	A,#TMRREFL	;dodanie do wartosci zmierzonej liczby
	add	A,{vvolts+1}	;odswiezajacej timer (wartosc ladowana do DCR0
	ld	{vvolts+1},A	;zawsze musi byc wieksza,od TMTREF!)
	ld	A,#TMRREFH
	adc	A,vvolts
	ld	vvolts,A
				;test,czy nie przekroczono wartosci maksymalnej 
	ld	A,#TMRMAXL	;przez odejmowanie od wartosci maksymalnej wartosci 
	sub	A,{vvolts+1}	;wyliczonej,jesli wystapi pozyczka,to nadanie
	ld	A,#TMRMAXH	;zmiennej vvolts wartosci maksymalnej dopuszczalnej
	sbc	A,vvolts
	jrnc	skipdef
	ld	A,#TMRMAXL
	ld	{vvolts+1},A
	ld	A,#TMRMAXH
	ld	vvolts,A
skipdef
	ld	A,vvolts		;zmiana zawartosci rejstrw generatora PWM
	ld	DCR0H,A
	ld	A,{vvolts+1}
	ld	DCR0L,A
	ld	A,#$01		;zezwolenie na zmiane wspolczynnika wypelnienia
				;przebiegu (TRANCR=0x01)
	ld	TRANCR,A
	jra	mloop


;-------------------------------------------------------
; "pusta" funkcja, zawiera tylko instrukcje powrotu
; z obslugi przerwania
;-------------------------------------------------------
it_ret	iret


	segment 'intvect'
;-------------------------------------------------------
; wektory przerwan
;-------------------------------------------------------
	DC.W	it_ret
	DC.W	it_ret
	DC.W	it_ret
.sci	DC.W	it_ret
.timb	DC.W	it_ret
.tima	DC.W	it_ret
.spi	DC.W	it_ret
	DC.W	it_ret
	DC.W	it_ret
.ext3	DC.W	it_ret
.ext2	DC.W	it_ret
.ext1	DC.W	it_ret
.ext0	DC.W	it_ret
	DC.W	it_ret
.soft	DC.W	it_ret
.rst	DC.W	main


	END
