;+--------------------------------------------------------------------------------------+
;| PROJECT: SApplication Note : Software UART using 12-bit ART							|
;| MODULE: LITE0_Map.INC									|
;| AUTHOR: Micro Application / STMicroelectronics								|
;| UPDATE: 30th June 2003									|
;| TARGET: 								|
;+--------------------------------------------------------------------------------------+
;| DESCRIPTION: Software UART for LITE0                          |
;+--------------------------------------------------------------------------------------+
;| VERSION 1.0.0:									|
;|	- First release									|
;+--------------------------------------------------------------------------------------+

        TITLE    "LITE0_Map.INC"           
                                        
                                        
        MOTOROLA                        
                                        

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;+--------------------------------------------------------------------------------------+
;| Hardware Register Map								|
;+--------------------------------------------------------------------------------------+

;****************************************************************************************
;| I/O Ports registers									|
;****************************************************************************************

PADR	equ	$00			; port A data register                          
PADDR	equ	$01			; port A data direction register                
PAOR	equ	$02			; port A option register                            

PBDR	equ	$03			; port B data register                          
PBDDR	equ	$04			; port B data direction register                
PBOR	equ	$05			; port B option register    

;****************************************************************************************
;| Lite Timer registers									|
;****************************************************************************************
LTCSR	equ	$0B			; Lite Timer Control/Status Register
LTICR	equ	$0C			; Lite Timer Input Capture Register

;****************************************************************************************
;| Auto Reload Timer Registers								|
;****************************************************************************************
ATCSR	equ	$0D			; Timer Control/Status Register
CNTRH	equ	$0E			; Counter Register High
CNTRL	equ	$0F			; Counter Register Low
ATRH	equ	$10			; Auto-Reload Register High
ATRL	equ	$11			; Auto-Reload Register Low
PWMCR	equ	$12			; PWM Output Control Register
PWM0CSR	equ	$13			; PWM 0 Control/Status Register

DCR0H	equ	$17			; PWM 0 Duty Cycle Register High
DCR0L   equ	$18			; PWM 0 Duty Cycle Register Low

;****************************************************************************************
;| Flash Memory Controller Registers							|
;****************************************************************************************
FCSR	equ	$2F			; Flash Control/Status Register


;****************************************************************************************
;| EEPROM Registers									|
;****************************************************************************************
EEPROM	equ	$30			; Data EEPROM Control/Status Register


;****************************************************************************************
;| SPI registers									|
;****************************************************************************************
SPIDR	equ	$31			; SPI Data Register                             
SPICR	equ	$32			; SPI Control Register                          
SPICSR	equ	$33			; SPI Control/Status Register                           


;****************************************************************************************
;| Analog To Digital Converter Registers						|
;****************************************************************************************
ADCCSR	equ	$34			; ADC Control Status Register                   
ADCDAT	equ	$35			; ADC Data Register                        
ADCAMP	equ	$36			; ADC Amplifier Control Register                        


;****************************************************************************************
;| Interrupt Controller Registers							|
;****************************************************************************************
EICR	equ	$37			;  External Interrupt control Register          


;****************************************************************************************
;| Master Clock Controller Registers							|
;****************************************************************************************
MCCSR	equ	$38			; Main Clock Control Status Register            


;****************************************************************************************
;| Clock and Reset Registers								|
;****************************************************************************************
RCCR	equ	$39			; RC oscillator Control Register
SICSR	equ	$3A			; System Integrity Control/Status Register



END